/*
 *	blanker.c   2000/04/12 Kenichi Kusakabe
 *
 *		LOCKUPɌĂяo֐ݒ
 *		APMݒ蓙_CAO
 */

#define INCL_DOS
#define INCL_WIN
#define INCL_ERRORS

#include	<string.h>
#include	<os2.h>
#include	"blanker.h"
#include	"blankerd.h"

HAB		Hab;
HMQ		Hmq;
HMODULE	HM_Hook;					// blankerd.dllHMODULE
const UCHAR	Title[] = {"Screen Blanker"};
UCHAR	SzIniFile[CCHMAXPATH];		// INIt@C̃tpX

BOOL	BUseAPM = FALSE;			// APMgCRTsuspend邩?
BOOL	BAPMAvail = FALSE;			// APM͎g?
long	LSleepMode = 2;				// X[ṽ[h(2:suspend)

HWND	HwndLockFrame = NULLHANDLE;	// lockup frame  HWND
HMQ		HmqLockFrame = NULLHANDLE;	// lockup frame  HMQ
BOOL	BKbHitEnable = FALSE;		// dpKbHitNotify()͗L
long	LRetryCount = 0;			// wakesretry

MRESULT EXPENTRY dlgProc( HWND, USHORT, MPARAM, MPARAM );
MRESULT EXPENTRY dpLockupNotify( HWND, USHORT, MPARAM, MPARAM );
MRESULT EXPENTRY dpKbHitNotify( HWND, USHORT, MPARAM, MPARAM );
APIRET	openAPM( HFILE * );
USHORT	sendPowerEvent( USHORT, USHORT );


/***************************************************************************
	main : C
***************************************************************************/
main( int argc, char *argv[] )
{
	UCHAR	buf[512];
	APIRET	rc;
	BOOL	b;
	HWND	hwndDlg;
	HINI	hini;
	UCHAR	*puc;
	ULONG	ul;

	if ( ( Hab = WinInitialize(0) ) == NULLHANDLE )	exit(1);
	if ( ( Hmq = WinCreateMsgQueue(Hab, 0) ) == NULLHANDLE ){
		goto quit1;
	}

		/* tbNɎgProc.̓DLL̃W[nh擾 */
	rc = DosLoadModule( buf, sizeof( buf ), "BLANKERD", &HM_Hook );
	if ( rc != NO_ERROR ){
		WinMessageBox(HWND_DESKTOP, HWND_DESKTOP,
			"Can't load module", Title, 0,
			MB_OK | MB_ERROR | MB_SYSTEMMODAL | MB_MOVEABLE);
		goto quit2;
	}

		/* DisplayAPMg? */
	if ( sendPowerEvent( 0x0100, 0 ) == 0 )	BAPMAvail = TRUE;
	else	BAPMAvail = FALSE;

		/* vt@Cǂݍ ... blankerd.dllƓfBNg[ */
	DosQueryModuleName( HM_Hook, CCHMAXPATH, SzIniFile );
	puc = strrchr( SzIniFile, '.' );
	strcpy( puc, ".ini" );
	hini = PrfOpenProfile( Hab, SzIniFile );
	ul = sizeof( BOOL );
	b = PrfQueryProfileData( hini, "Blanker", "APM", &BUseAPM, &ul );
	if ( !b ) BUseAPM = FALSE;
	ul = sizeof( long );
	b = PrfQueryProfileData( hini, "Blanker", "MODE", &LSleepMode, &ul );
	if ( !b ) LSleepMode = 2;
	PrfCloseProfile( hini );

		/* tbNݒ! */
	b = WinSetHook( Hab, NULLHANDLE, HK_LOCKUP, (PFN)myLockHook, HM_Hook );
	if ( b ){
		hwndDlg = WinLoadDlg( HWND_DESKTOP, HWND_DESKTOP, (PFNWP)dlgProc,
				NULLHANDLE, DLG_EXIT, NULL );
		if ( setDlgHwnd( hwndDlg ) ) {	// blankerĂfalse
			WinProcessDlg( hwndDlg );
			releaseDlgHwnd();
		}
		WinDestroyWindow( hwndDlg );
		WinReleaseHook( Hab, NULLHANDLE, HK_LOCKUP,
							(PFN)myLockHook, HM_Hook );
		if ( HmqLockFrame != NULLHANDLE ) {
			WinReleaseHook( Hab, HmqLockFrame, HK_INPUT,
					(PFN)lockFrameMsgHook, HM_Hook );
		}
	}
	else{
		WinMessageBox(HWND_DESKTOP, HWND_DESKTOP,
			"Fail to set lock-up hook", Title, 0,
			MB_OK | MB_ERROR | MB_SYSTEMMODAL | MB_MOVEABLE);
	}

quit2:
	WinDestroyMsgQueue (Hmq);
quit1:
	WinTerminate (Hab);

}


/***************************************************************************
	dlgProc : _CAOvV[W[
***************************************************************************/
MRESULT EXPENTRY
dlgProc( HWND hwndDlg, USHORT msg, MPARAM mp1, MPARAM mp2 )
{
	static HPOINTER	hptr;
	static BOOL	fFirst = TRUE;

	switch(msg){
	case WM_INITDLG:
		/*
		 *  _CAOɃACRݒ肷
		 */
		hptr = WinLoadPointer( HWND_DESKTOP, NULLHANDLE, IID_BLANKER );
		WinSendMsg( hwndDlg, WM_SETICON, (MPARAM)hptr, 0L );
/*		WinSetWindowPos( hwndDlg, NULLHANDLE, 0, 0, 0, 0, SWP_HIDE );
 *		 RȂAł͂͂߂ŏ邱Ƃ͂łȂB
 *			WM_INITDLG ̂ WinLoadDlg() B
 *			̌ WinProcessDlg() ɂ苭IACTIVATEB
 */
		if ( !BAPMAvail ) WinEnableControl(hwndDlg, DID_APM, FALSE);
		else if ( BUseAPM ) WinSendDlgItemMsg( hwndDlg, DID_APM,
									BM_SETCHECK, MPFROMSHORT( 1 ), MPVOID );
		WinSendDlgItemMsg( hwndDlg, DID_STBY + LSleepMode - 1,
						BM_SETCHECK, MPFROMSHORT( 1 ), MPVOID );
		return( (MRESULT)FALSE );

	case WM_DESTROY:
		WinDestroyPointer( hptr );			/* nYꂸ */
		return( WinDefDlgProc( hwndDlg, msg, mp1, mp2 ) );

	case WM_ACTIVATE:
		/* WinProcessDlgōŏActivateꂽƂɁAwindow𑦍ɍŏ */
		if ( fFirst && SHORT1FROMMP( mp1 ) ){
			fFirst = FALSE;
			WinSetWindowPos( hwndDlg, NULLHANDLE, 0, 0, 0, 0, SWP_MINIMIZE );
		}
		return( WinDefDlgProc( hwndDlg, msg, mp1, mp2 ) );

	case WM_LOCKUPNOTIFY:	//myLockHook()
		return( dpLockupNotify( hwndDlg, msg, mp1, mp2 ) );

	case WM_KBHITNOTIFY:	// lockFrameMsgHook()
		return( dpKbHitNotify( hwndDlg, msg, mp1, mp2 ) );

	case WM_COMMAND:
		if ( SHORT1FROMMP( mp1 ) == DID_OK ) {
			  /* `FbN{bNX̏Ԃ擾 */
			short s;
			HINI	hini;
			s = SHORT1FROMMR( WinSendDlgItemMsg( hwndDlg, DID_APM,
					BM_QUERYCHECK, MPVOID, MPVOID ) );
			if ( s == 1 ) BUseAPM = TRUE;
			else BUseAPM = FALSE;
			  /* ǂ̃WI{^`FbNĂ邩擾 */
			LSleepMode = SHORT1FROMMR( WinSendDlgItemMsg( hwndDlg, DID_STBY,
					BM_QUERYCHECKINDEX, MPVOID, MPVOID ) ) + 1;
			  /* vt@C */
			hini = PrfOpenProfile( Hab, SzIniFile );
			PrfWriteProfileData( hini, "Blanker", "APM",
				&BUseAPM, sizeof( BOOL ));
			PrfWriteProfileData( hini, "Blanker", "MODE",
				&LSleepMode, sizeof( long ));
			PrfCloseProfile( hini );
			  /* ŏ */
			WinSetWindowPos( hwndDlg, NULLHANDLE, 0, 0, 0, 0, SWP_MINIMIZE );
			return( (MRESULT)0 );
		}
		else return( WinDefDlgProc( hwndDlg, msg, mp1, mp2 ) );

	default:
		return( WinDefDlgProc( hwndDlg, msg, mp1, mp2 ) );
	}
}


/***************************************************************************
	dpLockupNotify : WM_LOCKUPNOTIFY(WM)
		LockupLockup framẽbZ[Ws悤ɐݒ肷B
		(myLockHook()烁bZ[W󂯎)
***************************************************************************/
MRESULT EXPENTRY
dpLockupNotify( HWND hwndDlg, USHORT msg, MPARAM mp1, MPARAM mp2 )
{
	BOOL	b;
	USHORT	us;

		/* APMgp\? */
	if ( !BUseAPM ) return( (MRESULT)FALSE );
	HwndLockFrame = HWNDFROMMP( mp1 );

		/* bNAbvEBhDHMQget */
	HmqLockFrame = (HMQ)WinQueryWindowULong( HwndLockFrame, QWL_HMQ );
	if ( HmqLockFrame == NULLHANDLE ) return( (MRESULT)FALSE );

		/* bZ[WBvZX̂ŁA֐DLLɒu */
	b = WinSetHook( Hab, HmqLockFrame, HK_INPUT,
			(PFN)lockFrameMsgHook, HM_Hook );
	if ( !b ) return( (MRESULT)FALSE );

		/* DisplaySuspend! */
	us = sendPowerEvent( 0x0100, 2 );
	if ( us != 0 ) {
			/* APMgȂȂtbNsv */
		WinReleaseHook( Hab, HmqLockFrame, HK_INPUT,
				(PFN)lockFrameMsgHook, HM_Hook );
		HmqLockFrame = NULLHANDLE;
		BKbHitEnable = FALSE;
	}
	else {
		BKbHitEnable = TRUE;
		LRetryCount = 0;
	}
	return( (MRESULT)FALSE );
}


/***************************************************************************
	dpKbHitNotify : WM_KBHITNOTIFY(WM)
		LockupLockup framẽbZ[Ws(dpLockupNotify())
		ăL[{[hꂽƂɂWMłB
		(lockFrameMsgHook()烁bZ[W󂯎)
***************************************************************************/
MRESULT EXPENTRY
dpKbHitNotify( HWND hwndDlg, USHORT msg, MPARAM mp1, MPARAM mp2 )
{
	USHORT	us;

		/* bZ[WƂ̂߂Ɂc */
	if ( !BKbHitEnable )	return( (MRESULT)FALSE );

		/* ͂≡sv */
	if ( HmqLockFrame != NULLHANDLE ) {
		WinReleaseHook( Hab, HmqLockFrame, HK_INPUT,
				(PFN)lockFrameMsgHook, HM_Hook );
		HmqLockFrame = NULLHANDLE;
	}

		/* DisplayWake up! */
	us = sendPowerEvent( 0x0100, 0 );
	if ( us == 0 ) {
		BKbHitEnable = FALSE;
	}
	else {	// x͑łAPM𑀍łȂȂĂƂ́ĉ?
		if ( LRetryCount++ < 20 ) {		// 20retry
			DosSleep( 500 );	// ǂłȂ璷҂Ă܂
			WinPostMsg( hwndDlg, WM_KBHITNOTIFY, MPVOID, MPVOID );
		}
		else {		// ߂EEE
			LRetryCount = 0;
			BKbHitEnable = FALSE;
		}
	}
	return( (MRESULT)FALSE );
}


/***************************************************************************
	openAPM : APM driver̃nh(HFILE)擾B(gpDosClose())
	param :	(HFILE*) Ɏ擾HFILE
	return:	(APIRET) G[NO_ERRORBDosOpen()QƁB
***************************************************************************/
APIRET
openAPM( HFILE *phfAPM )
{
	APIRET	rc;
	ULONG	ul;
	rc = DosOpen( "\\DEV\\APM$", phfAPM, &ul, 0, 0,
			OPEN_ACTION_FAIL_IF_NEW | OPEN_ACTION_OPEN_IF_EXISTS,
			OPEN_ACCESS_READWRITE | OPEN_SHARE_DENYNONE, NULL );
	return( rc );
}


/***************************************************************************
	sendPowerEvent : APM  Power State ύX Power event MB
	param :	(USHORT) foCXID
				0001h : All Devices
				01xxh : Display
				02xxh : Secondary Storage
				03xxh : Parallel Ports
				04xxh : Serial Ports
				05xxh : Network Adapters
				06xxh : PCMCIA Sockets
				etc...
					(xx = unit number start from 0)
			(USHORT) p[Xe[g
				0 : APM Enabled ( = Power ON )
				1 : Standby
				2 : Suspend
				3 : Off
				etc...
	return:	(USHORT)
				0000h ... PowerNoError
				0001h ... PowerBadSubId
				0002h ... PowerBadReserved
				0003h ... PowerBadDevId
				0004h ... PowerBadPwrState
				0009h ... PowerDisabled
				FFFFh ... Cannot open APM driver(Ǝǉ)
***************************************************************************/
USHORT
sendPowerEvent( USHORT usDevID, USHORT usPowState )
{
	HFILE	hfAPM;
	APIRET	rc;
	ULONG	ul1, ul2;
	USHORT	us;
	POW_EVENT	pev;

		/* APMhCo[̃nh擾 */
	rc = openAPM( &hfAPM );
	if ( rc != NO_ERROR ) return( 0xffff );

		/* IOCtl */
	pev.usSubID = 6;				// p[CxgM
	pev.usRsvd = 0;					// 0ɂ邱
	pev.usDevID = usDevID;			// foCXID
	pev.usPowState = usPowState;	// p[Xe[g
	ul1 = sizeof( pev );
	ul2 = sizeof( us );
	DosDevIOCtl( hfAPM, 0x0c, 0x40, &pev, sizeof(pev), &ul1,
			&us, sizeof(us), &ul2 );

		/* Yꂸclose */
	DosClose( hfAPM );
	return( us );
}

