CFLAGS = -Zomf -O2
LFLAGS = -Zomf -Zsys -Zlinker /EXEPACK:2
LFLAGDLL = -Zomf -Zno-rte -Zdll -Zlinker /EXEPACK:2
CC = gcc
BIN = blanker
EXE = $(BIN).exe
DEF = $(BIN).def
OBJ = $(BIN).obj
SRC = $(BIN).c
INC = $(BIN).h
RC  = $(BIN).rc
RES  = $(BIN).res
ICO  = $(BIN).ico

BIN3 = $(BIN)d
DLL = $(BIN3).dll
DEF3 = $(BIN3).def
LIB = $(BIN3).lib
OBJ3 = $(BIN3).obj
SRC3 = $(BIN3).c
INC3 = $(BIN3).h

default : $(EXE) $(DLL)

%.obj : %.c
	$(CC) $(CFLAGS) -c $<

%.lib : %.def
	emximp -o $@ $<

%.res : %.rc
	rc -X2 -r $<


$(LIB) : $(DEF3)

$(EXE) : $(OBJ) $(DEF) $(LIB) $(RES)
	$(CC) $(LFLAGS) -o $(EXE) $(OBJ) $(DEF) $(LIB) $(RES)

$(DLL)  : $(OBJ3) $(DEF3)
	$(CC) $(LFLAGDLL) -o $@ $^

$(OBJ)  : $(SRC) $(INC3) $(INC)
$(OBJ3) : $(SRC3) $(INC3) $(INC)

$(RES)  : $(RC) $(INC) $(ICO)


